%global repo deepin-kwin
%global __provides_exclude_from ^%{_qt5_plugindir}.*\.so$

Name:           deepin-kwin
Version:        5.25.12
Release:        %autorelease
Summary:        KWin configuration for Deepin Desktop Environment
License:        GPLv3+
URL:            https://github.com/linuxdeepin/%{repo}
Source0:        %{url}/archive/%{version}/%{repo}-%{version}.tar.gz

BuildRequires:  deepin-wayland-protocols-devel
BuildRequires:  kf5-filesystem
BuildRequires:  libcap-devel
BuildRequires:  libepoxy-devel
BuildRequires:  hicolor-icon-theme
BuildRequires:  hwdata
BuildRequires:  pkgconfig
BuildRequires:  systemd-rpm-macros
BuildRequires:  xz
BuildRequires:  cmake(Breeze)
BuildRequires:  cmake(DWayland)
BuildRequires:  cmake(KDecoration2)
BuildRequires:  cmake(KF5Activities)
BuildRequires:  cmake(KF5Completion)
BuildRequires:  cmake(KF5Config)
BuildRequires:  cmake(KF5ConfigWidgets)
BuildRequires:  cmake(KF5CoreAddons)
BuildRequires:  cmake(KF5Crash)
BuildRequires:  cmake(KF5DBusAddons)
BuildRequires:  cmake(KF5Declarative)
BuildRequires:  cmake(KF5DocTools)
BuildRequires:  cmake(KF5GlobalAccel)
BuildRequires:  cmake(KF5I18n)
BuildRequires:  cmake(KF5IconThemes)
BuildRequires:  cmake(KF5IdleTime)
BuildRequires:  cmake(KF5Init)
BuildRequires:  cmake(KF5KCMUtils)
BuildRequires:  cmake(KF5KIO)
BuildRequires:  cmake(KF5NewStuff)
BuildRequires:  cmake(KF5Notifications)
BuildRequires:  cmake(KF5Package)
BuildRequires:  cmake(KF5Plasma)
BuildRequires:  cmake(KF5Runner)
BuildRequires:  cmake(KF5Service)
BuildRequires:  cmake(KF5TextWidgets)
BuildRequires:  cmake(KF5Wayland)
BuildRequires:  cmake(KF5WidgetsAddons)
BuildRequires:  cmake(KF5WindowSystem)
BuildRequires:  cmake(KF5XmlGui)
BuildRequires:  cmake(KScreenLocker)
BuildRequires:  cmake(PlasmaWaylandProtocols)
BuildRequires:  cmake(QAccessibilityClient)
BuildRequires:  cmake(Qt5Concurrent)
BuildRequires:  cmake(Qt5Core)
BuildRequires:  cmake(Qt5DBus)
BuildRequires:  cmake(Qt5Quick)
BuildRequires:  cmake(Qt5QuickWidgets)
BuildRequires:  cmake(Qt5Script)
BuildRequires:  cmake(Qt5Sensors)
BuildRequires:  cmake(Qt5UiTools)
BuildRequires:  cmake(Qt5WaylandClient)
BuildRequires:  cmake(Qt5Widgets)
BuildRequires:  cmake(Qt5X11Extras)
BuildRequires:  pkgconfig(fontconfig)
BuildRequires:  pkgconfig(freetype2)
BuildRequires:  pkgconfig(ice)
BuildRequires:  pkgconfig(lcms2)
BuildRequires:  pkgconfig(libxcvt)
BuildRequires:  pkgconfig(sm)
BuildRequires:  pkgconfig(wayland-cursor)
BuildRequires:  pkgconfig(wayland-protocols)
BuildRequires:  pkgconfig(x11)
BuildRequires:  pkgconfig(x11-xcb)
BuildRequires:  pkgconfig(xau)
BuildRequires:  pkgconfig(xcb)
BuildRequires:  pkgconfig(xcb-composite)
BuildRequires:  pkgconfig(xcb-cursor)
BuildRequires:  pkgconfig(xcb-damage)
BuildRequires:  pkgconfig(xcb-glx)
BuildRequires:  pkgconfig(xcb-icccm)
BuildRequires:  pkgconfig(xcb-image)
BuildRequires:  pkgconfig(xcb-keysyms)
BuildRequires:  pkgconfig(xcb-randr)
BuildRequires:  pkgconfig(xcb-render)
BuildRequires:  pkgconfig(xcb-shape)
BuildRequires:  pkgconfig(xcb-shm)
BuildRequires:  pkgconfig(xcb-sync)
BuildRequires:  pkgconfig(xcb-util)
BuildRequires:  pkgconfig(xcb-xfixes)
BuildRequires:  pkgconfig(xi)
BuildRequires:  pkgconfig(xkbcommon)
BuildRequires:  pkgconfig(xscrnsaver)
BuildRequires:  pkgconfig(xtst)
BuildRequires:  pkgconfig(gbm)
BuildRequires:  pkgconfig(libdrm)
BuildRequires:  pkgconfig(libinput)
BuildRequires:  pkgconfig(libudev)
BuildRequires:  pkgconfig(wayland-egl)
BuildRequires:  pkgconfig(xwayland)
Requires:       plasma-breeze
Requires:       kdialog
Requires:       kf5-kirigami2
Requires:       kf5-kitemmodels
Recommends:     xorg-x11-server-wayland
# since F31
Obsoletes:      deepin-wm <= 1.9.38
Obsoletes:      deepin-wm-switcher <= 1.1.9
Obsoletes:      deepin-metacity <= 3.22.24
Obsoletes:      deepin-metacity-devel <= 3.22.24
Obsoletes:      deepin-mutter <= 3.20.38
Obsoletes:      deepin-mutter-devel <= 3.20.38

%description
This package provides a kwin configuration that used as the new WM for Deepin
Desktop Environment.

%package devel
Summary:        Development package for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       kwin-devel%{?_isa}
Requires:       qt5-qtx11extras-devel%{?_isa}
Requires:       gsettings-qt-devel%{?_isa}
Requires:       dtkcore-devel%{?_isa}
Requires:       kf5-kglobalaccel-devel%{?_isa}

%description devel
Header files and libraries for %{name}.

%prep
%autosetup -p1 -n %{repo}-%{version}

%build
# help find (and prefer) qt5 utilities, e.g. qmake, lrelease
export PATH=%{_qt5_bindir}:$PATH
%cmake -DCMAKE_INSTALL_PREFIX=%{_prefix} \
       -DCMAKE_INSTALL_LIBDIR=%{_libdir} \
       -DCMAKE_INSTALL_LIBEXECDIR=%{_libexecdir} \
       -DINCLUDE_INSTALL_DIR=%{_includedir}/%{name} \
       -DCMAKE_BUILD_TYPE=RelWithDebInfo

%cmake_build

%install
%cmake_install

%files
%doc README.md README.zh_CN.md
# %license LICENSE
%dir %{_sysconfdir}/skel/.config
%config %{_sysconfdir}/skel/.config/kglobalshortcutsrc
%config %{_sysconfdir}/xdg/deepin-*
%config %{_sysconfdir}/xdg/kglobalshortcutsrc
%{_bindir}/%{name}_wayland
%{_bindir}/%{name}_wayland_wrapper
%{_bindir}/%{name}_x11
%{_datadir}/applications/*.desktop
%{_datadir}/qlogging-categories5/org_kde_%{name}.categories
%{_datadir}/knsrcfiles/*.knsrc
%{_libdir}/kconf_update_bin/
%{_libdir}/lib%{name}*.so.*
%{_libdir}/libdeepin-kcmkwincommon.so.*
%{_libdir}/qt5/plugins/%{name}
%{_libdir}/qt5/plugins/kcms
%{_libdir}/qt5/plugins/*.so
%dir %{_libdir}/qt5/plugins/kpackage/
%dir %{_libdir}/qt5/plugins/kpackage/packagestructure/
%{_libdir}/qt5/plugins/kpackage/packagestructure/*.so
%dir %{_datadir}/kpackage
%dir %{_datadir}/kpackage/kcms
%{_datadir}/kpackage/kcms/deepin-*
%{_libdir}/qt5/plugins/org.kde.*
%{_libexecdir}/%{name}_*
%{_libexecdir}/%{name}-applywindowdecoration
%{_datadir}/config.kcfg/
%{_datadir}/%{name}
%{_datadir}/icons/hicolor/*/apps/%{name}.*
%{_datadir}/kconf_update/
%{_datadir}/kservices5
%{_datadir}/kservicetypes5
%{_datadir}/knotifications5
%dir %{_datadir}/dsg
%dir %{_datadir}/dsg/configs
%dir %{_datadir}/dsg/configs/org.deepin.kwin
%{_datadir}/dsg/configs/org.deepin.kwin/org.deepin.kwin.splitmenu.display.json
%dir %{_datadir}/krunner
%dir %{_datadir}/krunner/dbusplugins
%{_datadir}/krunner/dbusplugins/%{name}-runner-windows.desktop
%dir %{_libdir}/qt5/qml/org/
%dir %{_libdir}/qt5/qml/org/deepin
%dir %{_libdir}/qt5/qml/org/deepin/kwin
%dir %{_libdir}/qt5/qml/org/deepin/kwin/decoration
%{_libdir}/qt5/qml/org/deepin/kwin/decoration/*.qml
%{_libdir}/qt5/qml/org/deepin/kwin/decoration/libdecorationplugin.so
%{_libdir}/qt5/qml/org/deepin/kwin/decoration/qmldir
%dir %{_libdir}/qt5/qml/org/kde/
%{_libdir}/qt5/qml/org/kde/%{name}
# %{_userunitdir}/%{name}_wayland.service
# %{_userunitdir}/%{name}_x11.service

%dir %{_datadir}/doc/HTML
%dir %{_datadir}/doc/HTML/en
%dir %{_datadir}/doc/HTML/en/dcontrol
%{_datadir}/doc/HTML/en/dcontrol/*

%dir %{_datadir}/translations
%{_datadir}/translations/popupmenu

%files devel
%{_libdir}/lib%{name}*.so
%{_libdir}/cmake/DeepinKWinEffects
%{_libdir}/cmake/DeepinKWinDBusInterface
%{_includedir}/%{name}
%{_datadir}/dbus-1/interfaces/

%changelog
%autochangelog
